<template>
  <div class="app-container">
    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="客户名称" prop="cusName">
        <el-input v-model="queryParams.cusName" placeholder="请输入客户名称" clearable
                  @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="联系方式" prop="phoneNumber">
        <el-input v-model="queryParams.phoneNumber" placeholder="请输入联系方式" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="身份证号" prop="idCard">
        <el-input v-model="queryParams.idCard" placeholder="请输入身份证号" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="openForm(undefined)"
                   v-hasPermi="['base:customer-main:create']">新增
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
      <el-table-column width="100" label="客户名称" align="center" prop="cusName"/>
      <el-table-column width="80" label="会员等级" align="center" prop="levelName" />
      <el-table-column width="60" label="性别" align="center" prop="sex">
        <template v-slot="scope">
          <dict-tag :type="DICT_TYPE.DICT_SYS_USER_SEX" :value="scope.row.sex" />
        </template>
      </el-table-column>
      <el-table-column width="110" label="联系方式" align="center" prop="phoneNumber"/>
      <el-table-column width="100" label="生日" align="center" prop="birthday">
        <template v-slot="scope">
          <span>{{ parseTime(scope.row.birthday,'{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="住址" align="left" prop="address"/>
      <el-table-column width="100" label="客户来源" align="center" prop="dataFrom">
        <template v-slot="scope">
          <dict-tag :type="DICT_TYPE.DICT_CUS_DATA_FROM" :value="scope.row.dataFrom" />
        </template>
      </el-table-column>
      <el-table-column width="100" label="最近办理业务" align="center" prop="nearDoContent">
        <template v-slot="scope">
          <dict-tag :type="DICT_TYPE.DICT_CUS_BUSI_TYPE" :value="scope.row.nearDoContent" />
        </template>
      </el-table-column>
      <el-table-column label="最近业务办理时间" align="center" prop="nearDoTime" width="180">
        <template v-slot="scope">
          <span>{{ parseTime(scope.row.nearDoTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column width="150" fixed="right" label="客户状态" align="center" prop="status">
        <template v-slot="scope">
          <dict-tag :type="DICT_TYPE.DICT_CUS_INFO_STATUS" :value="scope.row.status" />
        </template>
      </el-table-column>

      <el-table-column
        fixed="right"
        label="操作"
        width="150"
        align="center"
        class-name="small-padding fixed-width">
        <template v-slot="scope">

          <el-button size="mini" type="text" icon="el-icon-edit" @click="openForm(scope.row.id)"
                     v-hasPermi="['base:customer-main:update']">修改
          </el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['base:customer-main:delete']">删除
          </el-button>
          <el-dropdown @command="(command) => handleCommand(command, scope.$index, scope.row)" v-hasPermi="['base:customer-main:update', 'base:customer-main:delete']">
            <el-button size="mini" type="text" icon="el-icon-d-arrow-right">更多</el-button>
            <el-dropdown-menu slot="dropdown">
              <el-dropdown-item command="bindCar" size="mini" type="text" icon="el-icon-truck"
                                v-hasPermi="['base:customer-main:car']">绑定车辆</el-dropdown-item>
              <el-dropdown-item command="bindLabel" size="mini" type="text" icon="el-icon-s-management">打标签</el-dropdown-item>

            </el-dropdown-menu>
          </el-dropdown>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>
    <!-- 对话框(添加 / 修改) -->
    <CustomerMainForm ref="formRef" @success="getList"/>
    <CustomerCarForm ref="carFormRef" @success="getList"/>
    <CustomerLabelForm ref="labelFormRef" @success="getList"/>
  </div>
</template>

<script>
import * as CustomerMainApi from '@/api/base/customer';
import CustomerMainForm from '@/views/base/customer/CustomerMainForm.vue';
import CustomerCarForm from '@/views/base/customer/CustomerCarForm.vue';
import CustomerLabelForm from '@/views/base/customer/CustomerLabelForm.vue';
export default {
  name: "TodoCustomer",
  components: {
    CustomerMainForm,CustomerCarForm,CustomerLabelForm
  },
  props:{
    typeCode: {
      type: String,
      default: '01'
    },
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 客户管理列表
      list: [],
      // 是否展开，默认全部展开
      isExpandAll: true,
      // 重新渲染表格状态
      refreshTable: true,
      // 选中行
      currentRow: {},
      activeName:'private',
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        userId: null,
        typeCode: '02',
        deptCode: null,
        cusName: null,
        phoneNumber: null,
        birthday: null,
        address: null,
        sex: null,
        idCard: null,
        idCardImage: null,
        dataFrom: null,
        nearDoTime: [],
        nearDoContent: null,
        inviter: null,
        inviterType: null,
        status: null,
        createTime: [],
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /**更多操作*/
    handleCommand(command, index, row) {
      switch (command) {
        case 'bindCar':
          //绑定车辆信息
          this.bindCar(row);
          break;
        case 'bindLabel':
          this.bindLabel(row);
          break;
        default:
          break;
      }
    },
    /**
     * 绑定车辆
     */
    bindCar(row){
      this.$refs["carFormRef"].open(row);
    },
    /**打标签*/
    bindLabel(row){
      this.$refs["labelFormRef"].open(row);
    },
    /** 查询列表 */
    async getList() {
      try {
        this.loading = true;
        const res = await CustomerMainApi.getCustomerMainPage(this.queryParams);
        this.list = res.data.records;
        this.total = res.data.total;
      } finally {
        this.loading = false;
      }
    },

    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 添加/修改操作 */
    openForm(id) {
      this.$refs["formRef"].open(id,this.queryParams.typeCode);
    },
    /** 删除按钮操作 */
    async handleDelete(row) {
      const id = row.id;
      await this.$modal.confirm('是否确认删除客户"' + row.cusName)
      try {
        await CustomerMainApi.deleteCustomerMain(id);
        await this.getList();
        this.$modal.msgSuccess("删除成功");
      } catch {
      }
    },
    /** 导出按钮操作 */
    async handleExport() {
      await this.$modal.confirm('是否确认导出所有客户管理数据项?');
      try {
        this.exportLoading = true;
        const data = await CustomerMainApi.exportCustomerMainExcel(this.queryParams);
        this.$download.excel(data, '客户管理.xls');
      } catch {
      } finally {
        this.exportLoading = false;
      }
    },
  }
};
</script>

